import { SemanticMark } from './semantic-mark';
import type { ImageEncodeChannels, WithDefaultEncode, PlotImageEncoderSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf } from '@visactor/vgrammar-core';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class ImageSemanticMark extends SemanticMark<PlotImageEncoderSpec, ImageEncodeChannels> {
    static readonly type = PlotMakType.image;
    static defaultSpec: PlotImageEncoderSpec;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<PlotImageEncoderSpec, ImageEncodeChannels>, ImageEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: ImageEncodeChannels, option: ValueOf<WithDefaultEncode<PlotImageEncoderSpec, ImageEncodeChannels>, ImageEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotImageEncoderSpec, ImageEncodeChannels>): GenerateBaseEncodeSpec<PlotImageEncoderSpec>;
}
