import type { IntervalEncodeChannels, PlotIntervalEncoderSpec, SemanticTooltipOption, WithDefaultEncode, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, CrosshairSpec, AttributeTransform, TransformSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class Interval extends SemanticMark<PlotIntervalEncoderSpec, IntervalEncodeChannels> {
    static readonly type = PlotMakType.interval;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType.arc | GrammarMarkType.rect;
    parseScaleByEncode(channel: IntervalEncodeChannels, option: ValueOf<WithDefaultEncode<PlotIntervalEncoderSpec, IntervalEncodeChannels>, IntervalEncodeChannels>): ScaleSpec | Nil;
    setDefaultMarkTransform(): TransformSpec[];
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    setMainMarkSpec(): {
        attributeTransforms: AttributeTransform[];
    } | {
        attributeTransforms?: undefined;
    };
    convertMarkEncode(encode: WithDefaultEncode<PlotIntervalEncoderSpec, IntervalEncodeChannels>): GenerateBaseEncodeSpec<PlotIntervalEncoderSpec>;
}
