import { SemanticMark } from "./semantic-mark";

import { GrammarMarkType } from "@visactor/vgrammar-core";

import { PlotMakType } from "./enums";

export class RuleX extends SemanticMark {
    constructor(id) {
        super(PlotMakType.ruleX, id);
    }
    setMarkType() {
        return GrammarMarkType.rule;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            x: markEncoder.x,
            x1: markEncoder.x,
            y: (datum, el, params) => 0,
            y1: (datum, el, params) => params.viewBox.height()
        };
        return markEncoder.color || markEncoder.group ? res.stroke = null !== (_a = markEncoder.color) && void 0 !== _a ? _a : markEncoder.group : res.stroke = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.stroke) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0], 
        res;
    }
}

RuleX.type = PlotMakType.ruleX;
//# sourceMappingURL=rule-x.js.map